]> arthur.barton.de Git - netdata.git/blobdiff - charts.d/squid.chart.sh
added IPMI alarms
[netdata.git] / charts.d / squid.chart.sh
old mode 100755 (executable)
new mode 100644 (file)
index a9bcea2..2c19c35
@@ -1,14 +1,65 @@
-#!/bin/sh
+# no need for shebang - this file is loaded from charts.d.plugin
+
+# netdata
+# real-time performance and health monitoring, done right!
+# (C) 2016 Costa Tsaousis <costa@tsaousis.gr>
+# GPL v3+
+#
+
+squid_host=
+squid_port=
+squid_url=
+squid_timeout=2
+squid_update_every=2
+squid_priority=60000
+
+squid_get_stats_internal() {
+       local host="$1" port="$2" url="$3"
+       run squidclient -h $host -p $port $url
+}
 
-squid_url="http://127.0.0.1:8080/squid-internal-mgr/counters"
-squid_update_every=5
+squid_get_stats() {
+       squid_get_stats_internal "$squid_host" "$squid_port" "$squid_url"
+}
+
+squid_autodetect() {
+       local host="127.0.0.1" port url x
+
+       for port in 3128 8080
+       do
+               for url in "cache_object://$host:$port/counters" "/squid-internal-mgr/counters"
+               do
+                       x=$(squid_get_stats_internal "$host" "$port" "$url" | grep client_http.requests)
+                       if [ ! -z "$x" ]
+                               then
+                               squid_host="$host"
+                               squid_port="$port"
+                               squid_url="$url"
+                               debug "found squid at '$host:$port' with url '$url'"
+                               return 0
+                       fi
+               done
+       done
+
+       error "cannot find squid running in localhost. Please set squid_url='url' and squid_host='IP' and squid_port='PORT' in $confd/squid.conf"
+       return 1
+}
 
 squid_check() {
+       require_cmd squidclient || return 1
+       require_cmd sed || return 1
+       require_cmd egrep || return 1
+
+       if [ -z "$squid_host" -o -z "$squid_port" -o -z "$squid_url" ]
+               then
+               squid_autodetect || return 1
+       fi
+
        # check once if the url works
-       wget 2>/dev/null -O /dev/null "$squid_url"
-       if [ ! $? -eq 0 ]
+       local x="$(squid_get_stats | grep client_http.requests)"
+       if [ ! $? -eq 0 -o -z "$x" ]
        then
-               echo >&2 "squid: cannot fetch the counters url: $squid_url. Please set squid_url='url' in $confd/squid.conf"
+               error "cannot fetch URL '$squid_url' by connecting to $squid_host:$squid_port. Please set squid_url='url' and squid_host='host' and squid_port='port' in $confd/squid.conf"
                return 1
        fi
 
@@ -18,25 +69,25 @@ squid_check() {
 squid_create() {
        # create the charts
        cat <<EOF
-CHART squid.clients_net '' "Squid Client Bandwidth" "kilobits / $squid_update_every sec" squid '' area 20001 $squid_update_every
+CHART squid_local.clients_net '' "Squid Client Bandwidth" "kilobits / sec" clients squid.clients.net area $((squid_priority + 1)) $squid_update_every
 DIMENSION client_http_kbytes_in in incremental 8 1
 DIMENSION client_http_kbytes_out out incremental -8 1
 DIMENSION client_http_hit_kbytes_out hits incremental -8 1
 
-CHART squid.clients_requests '' "Squid Client Requests" "requests / $squid_update_every sec" squid '' line 20003 $squid_update_every
+CHART squid_local.clients_requests '' "Squid Client Requests" "requests / sec" clients squid.clients.requests line $((squid_priority + 3)) $squid_update_every
 DIMENSION client_http_requests requests incremental 1 1
 DIMENSION client_http_hits hits incremental 1 1
 DIMENSION client_http_errors errors incremental -1 1
 
-CHART squid.servers_net '' "Squid Server Bandwidth" "kilobits / $squid_update_every sec" squid '' area 20002 $squid_update_every
+CHART squid_local.servers_net '' "Squid Server Bandwidth" "kilobits / sec" servers squid.servers.net area $((squid_priority + 2)) $squid_update_every
 DIMENSION server_all_kbytes_in in incremental 8 1
 DIMENSION server_all_kbytes_out out incremental -8 1
 
-CHART squid.servers_requests '' "Squid Server Requests" "requests / $squid_update_every sec" squid '' line 20004 $squid_update_every
+CHART squid_local.servers_requests '' "Squid Server Requests" "requests / sec" servers squid.servers.requests line $((squid_priority + 4)) $squid_update_every
 DIMENSION server_all_requests requests incremental 1 1
 DIMENSION server_all_errors errors incremental -1 1
 EOF
-       
+
        return 0
 }
 
@@ -49,7 +100,7 @@ squid_update() {
        # for each dimension
        # remember: KEEP IT SIMPLE AND SHORT
 
-       # 1. wget the counters page from squid
+       # 1. get the counters page from squid
        # 2. sed to remove spaces; replace . with _; remove spaces around =; prepend each line with: local squid_
        # 3. egrep lines starting with:
        #    local squid_client_http_ then one or more of these a-z 0-9 _ then = and one of more of 0-9
@@ -60,30 +111,30 @@ squid_update() {
        # prepare the script and always grep at the end the lines that are usefull, so that
        # even if something goes wrong, no other code can be executed
 
-       eval "`wget 2>/dev/null -O - "$squid_url" |\
-               sed -e "s/ \+/ /g" -e "s/\./_/g" -e "s/ = /=/g" -e "s/^/local squid_/g" |\
-               egrep "^local squid_(client_http|server_all)_[a-z0-9_]+=[0-9]+$"`"
+       eval "$(squid_get_stats |\
+                sed -e "s/ \+/ /g" -e "s/\./_/g" -e "s/^\([a-z0-9_]\+\) *= *\([0-9]\+\)$/local squid_\1=\2/g" |\
+               egrep "^local squid_(client_http|server_all)_[a-z0-9_]+=[0-9]+$")"
 
        # write the result of the work.
        cat <<VALUESEOF
-BEGIN squid.clients_net $1
+BEGIN squid_local.clients_net $1
 SET client_http_kbytes_in = $squid_client_http_kbytes_in
 SET client_http_kbytes_out = $squid_client_http_kbytes_out
 SET client_http_hit_kbytes_out = $squid_client_http_hit_kbytes_out
 END
 
-BEGIN squid.clients_requests $1
+BEGIN squid_local.clients_requests $1
 SET client_http_requests = $squid_client_http_requests
 SET client_http_hits = $squid_client_http_hits
 SET client_http_errors = $squid_client_http_errors
 END
 
-BEGIN squid.servers_net $1
+BEGIN squid_local.servers_net $1
 SET server_all_kbytes_in = $squid_server_all_kbytes_in
 SET server_all_kbytes_out = $squid_server_all_kbytes_out
 END
 
-BEGIN squid.servers_requests $1
+BEGIN squid_local.servers_requests $1
 SET server_all_requests = $squid_server_all_requests
 SET server_all_errors = $squid_server_all_errors
 END
@@ -91,4 +142,3 @@ VALUESEOF
 
        return 0
 }
-